package main

import (
	"fmt"
	"query-service/internal/aql"
	"query-service/internal/consumer"
	"query-service/internal/errorhandler"
)

func main() {

	exchangeID := "query-requests"
	routingKey := "aql-user-request"
	consumer.StartConsuming(onMessageReceived, exchangeID, routingKey)
}

func onMessageReceived(jsonMsg *[]byte) {
	// Retrieve JSON formatted string payload from msg

	// Convert the json byte msg to an aql query string
	aqlQuery, err := aql.ConvertJSONToAQL(jsonMsg)
	errorhandler.FailWithError(err, "failed to parse incoming msg to AQL") // TODO: don't panic on error, send error message to client instead

	fmt.Println(*aqlQuery)

	// execute and retrieve result

	// convert result to general (node-link (?)) format

	// publish converted result
}
